% This script produces forecasts from the random walk model

model_name = 'RW';
yhat1  = zeros(T-1-T0+1,n+1);  
yhat2  = zeros(T-2-T0+1,n+1);
yhat3  = zeros(T-3-T0+1,n+1);
tempyhat1 = zeros(nloop-burnin,n+1);  %% log prelike
tempyhat2 = zeros(nloop-burnin,n+1); 
tempyhat3 = zeros(nloop-burnin,n+1); 

%% prior
nu0 = 3; S0 = (nu0-1)*eye(n);

disp(['Starting the recursive forecasting exercise for ' model_name '....']);

for t = T0:T-1
    disp([ num2str(t-T) ' more loops to go... ' ] );
    shortYt = shortY(1:t,:);    
     Tt = size(shortYt,1);
    Yt = reshape(shortYt',Tt*n,1);   
    X = [Y0(end,:); shortYt(1:Tt-1,1:n)];
    err = reshape(Yt,n,Tt) - X';
    newS = S0 + err*err';
    newnu = nu0 + Tt;    
    rand('state', sum(100*clock) ); randn('state', sum(200*clock) );
    
    for loop = 1:nloop 
        %% sample Sig
        Sig = iwishrnd(newS,newnu);    
        
        if loop>burnin %% compute various forecasts
            i = loop-burnin;
            z1 = shortYt(end,:)';           
            
            tempyhat1(i,:) = [log(normpdf(shortY(t+1,:),z1',sqrt(diag(Sig))')) ...
                log(mvnpdf(shortY(t+1,:)',z1,Sig))];
            if t<=T-2
                Sig2 = 2*Sig;
                tempyhat2(i,:) = [log(normpdf(shortY(t+2,:),z1',sqrt(diag(Sig2))')) ...
                    log(mvnpdf(shortY(t+2,:)',z1,Sig2))];                
            end
            if t<=T-3
                Sig3 = 3*Sig;
                tempyhat3(i,:) = [log(normpdf(shortY(t+3,:),z1',sqrt(diag(Sig3)')))...
                    log(mvnpdf(shortY(t+3,:)',z1,Sig3))];
            end           
        end    
    end    
    maxy1 = max(tempyhat1);
    maxy2 = max(tempyhat2);
    maxy3 = max(tempyhat3);    
    yhat1(t-T0+1,:)  = log(mean(exp(tempyhat1-repmat(maxy1,nloop-burnin,1))))+maxy1; 
    if  t<=T-2
        yhat2(t-T0+1,:) = log(mean(exp(tempyhat2-repmat(maxy2,nloop-burnin,1))))+maxy2; 
    end
    if  t<=T-3
        yhat3(t-T0+1,:) = log(mean(exp(tempyhat3-repmat(maxy3,nloop-burnin,1))))+maxy3; 
    end
end



 