% This script produces forecasts from the VAR(p)

model_name = ['VAR('  num2str(p) ')'];
yhat1  = zeros(T-1-T0+1,n+1);  
yhat2  = zeros(T-2-T0+1,n+1);
yhat3  = zeros(T-3-T0+1,n+1);

%% prior
temp1 = ones(k,1);
invVbeta = sparse(1:k,1:k,temp1');
nu0 = 3; S0 = (nu0-1)*eye(n);

disp(['Starting the recursive forecasting exercise for ' model_name '....']);
for t = T0:T-1
    disp([ num2str(t-T) ' more loops to go... ' ] );
    shortYt = shortY(1:t,:);    
    Tt = size(shortYt,1);
    Yt = reshape(shortYt',Tt*n,1);  
    P = zeros(p*n,p*n);
    P(n+1:end,1:(p-1)*n) = eye((p-1)*n);
    X = zeros(Tt,p*n);
    for j = 1:p
        X(:,(j-1)*n+1:j*n) = [Y0(end-j+1:end,:); shortY(1:Tt-j,1:n)];
    end
    X = [ones(Tt,1) X];
    
    estimate_VAR;

    yhat1(t-T0+1,:)  = log(mean(exp(tempyhat1-repmat(maxy1,nloop-burnin,1))))+maxy1; 
    if  t<=T-2
        yhat2(t-T0+1,:) = log(mean(exp(tempyhat2-repmat(maxy2,nloop-burnin,1))))+maxy2; 
    end
    if  t<=T-3
        yhat3(t-T0+1,:) = log(mean(exp(tempyhat3-repmat(maxy3,nloop-burnin,1))))+maxy3; 
    end
end
 