% This script produces forecasts from the TVP-VARMA(p,1)-SV2, i.e.,
% VARMA(p,1) with time-varying VAR coefficients, time-varying volatility
% for f and time-varying phi

q = 1;  % forecasts are computed assuming p <= 4, q = 1
model_name = ['TVP-VARMA(' num2str(p) ',' num2str(q) ')-SV2'];

kp = n*(n-1)/2 + n^2*q; % number of MA coefficients
idB = zeros(kp,1);
count=0;
for i=1:n
    idB(count+1:count+i-1+n*q) = sub2ind([n n*(q+1)],i*ones(1,i-1+n*q),[1:i-1 n+1:n*(q+1)]);
    count = count + i-1 + n*q;
end
B = zeros(n,(q+1)*n);
B(:,1:n) = eye(n);
yhat1  = zeros(T-1-T0+1,n+1);  
yhat2  = zeros(T-2-T0+1,n+1);
yhat3  = zeros(T-3-T0+1,n+1);

%% prior
nuLam = 0; S0Lam = .1*ones(n,1);
VSigh = .01*ones(n,1);
VSigphi = .001*ones(kp,1);
VSigbeta = .001*ones(kb,1);
Vh = 5;
Vphi = 1;
Vbeta = ones(kb,1);
disp(['Starting the recursive forecasting exercise for ' model_name '....']);
for t = T0:T-1
    disp([ num2str(t-T) ' more loops to go... ' ] );
    shortYt = shortY(1:t,:);    
    Tt = size(shortYt,1);
    Yt = reshape(shortYt',Tt*n,1);  
    P = zeros(p*n,p*n);
    P(n+1:end,1:(p-1)*n) = eye((p-1)*n);
    X = zeros(Tt,p*n);
    for j = 1:p
        X(:,(j-1)*n+1:j*n) = [Y0(end-j+1:end,:); shortY(1:Tt-j,1:n)];
    end    
    
    estimate_VARMA_TVP_SV2;
  
    yhat1(t-T0+1,:)  = log(mean(exp(tempyhat1-repmat(maxy1,nloop-burnin,1))))+maxy1; 
    if  t<=T-2
        yhat2(t-T0+1,:) = log(mean(exp(tempyhat2-repmat(maxy2,nloop-burnin,1))))+maxy2; 
    end
    if  t<=T-3
        yhat3(t-T0+1,:) = log(mean(exp(tempyhat3-repmat(maxy3,nloop-burnin,1))))+maxy3; 
    end
end