% compute 1-, 2- and 3-step-ahead forecasts for VAR(p)
% forecasts are computed assuming p <= 4

i = loop-burnin;
tempbeta = reshape(beta,p*n+1,n)';
mu = tempbeta(:,1);
B = tempbeta(:,2:end);
Xt = reshape(shortYt(end:-1:end-p+1,:)', n*p,1);     
z1 = mu + B*Xt;

z1shortYt = [z1'; shortYt(end:-1:end-p+2,:)]';
Xt = reshape(z1shortYt( :, 1:p ),n*p,1);
z2 = mu + B*Xt;
z1z2shortYt = [z2'; z1'; shortYt(end:-1:end-p+3,:)]';
Xt = reshape(z1z2shortYt( :, 1:p ),n*p,1);
z3 = mu + B*Xt;  
            
tempyhat1(i,:) = [log(normpdf(shortY(t+1,:),z1',sqrt(diag(Sig))')) ...
    log(mvnpdf(shortY(t+1,:)',z1,Sig))];
if t<=T-2
    Sig2 = Sig;
    if p >= 1
        B1 = B(:,1:n);
        Sig2 = Sig2+B1*Sig*B1';
    end
    tempyhat2(i,:) = [log(normpdf(shortY(t+2,:),z2',sqrt(diag(Sig2))')) ...
        log(mvnpdf(shortY(t+2,:)',z2,Sig2))];                
end
if t<=T-3
    Sig3 = Sig;
    if p >= 1
        B1 = B(:,1:n);
        Sig3 = Sig3+B1*Sig*B1';
    end
    if p >= 2
        B2 = B(:,n+1:2*n);
        Sig3 = Sig3+(B1^2+B2)*Sig*(B1^2+B2)';
    end
    tempyhat3(i,:) = [log(normpdf(shortY(t+3,:),z3',sqrt(diag(Sig3)')))...
        log(mvnpdf(shortY(t+3,:)',z3,Sig3))];
end     