% compute 1-, 2- and 3-step-ahead forecasts for VAR(p)-SV
% forecasts are computed assuming p <= 4

i = loop-burnin;            
tempbeta = reshape(beta,p*n+1,n)';
mu = tempbeta(:,1);
B = tempbeta(:,2:end);
Xt = reshape(shortYt(end:-1:end-p+1,:)', n*p,1);     
z1 = mu + B*Xt;
h1 = h(end,:)' + sqrt(Sigh).*randn(n,1);
a1 = a(end) + sqrt(Siga).*randn(m,1);
L(Lfree) = a1;
Sig1 = (L\sparse(1:n,1:n,exp(h1)))/L';
Ytp1 = z1 + chol(Sig1,'lower')*randn(n,1);
                        
shortYtp1 = [Ytp1'; shortYt(end:-1:end-p+2,:)]';
Xt = reshape(shortYtp1(:,1:p),n*p,1);
z2 = mu + B*Xt;
h2 = h1 + sqrt(Sigh).*randn(n,1);
a2 = a1 + sqrt(Siga).*randn(m,1);
L(Lfree) = a2;
Sig2 = (L\sparse(1:n,1:n,exp(h2)))/L';
Ytp2 = z2 + chol(Sig2,'lower')*randn(n,1);            
            
shortYtp2 = [Ytp2'; Ytp1'; shortYt(end:-1:end-p+3,:)]';
Xt = reshape(shortYtp2( :, 1:p ),n*p,1);
z3 = mu + B*Xt; 
h3 = h2 + sqrt(Sigh).*randn(n,1);
a3 = a2 + sqrt(Siga).*randn(m,1);
L(Lfree) = a3;
Sig3 = (L\sparse(1:n,1:n,exp(h3)))/L';
Ytp3 = z3 + chol(Sig3,'lower')*randn(n,1);            
            
tempyhat1(i,:) = [log(normpdf(shortY(t+1,:),Ytp1',sqrt(diag(Sig1))')) ...
    log(mvnpdf(shortY(t+1,:)',Ytp1,Sig1))];
if t<=T-2
    tempyhat2(i,:) = [log(normpdf(shortY(t+2,:),Ytp2',sqrt(diag(Sig2))')) ...
        log(mvnpdf(shortY(t+2,:)',Ytp2,Sig2))];                
end
if t<=T-3
    tempyhat3(i,:) = [log(normpdf(shortY(t+3,:),Ytp3',sqrt(diag(Sig3)')))...
        log(mvnpdf(shortY(t+3,:)',Ytp3,Sig3))];
end  