%% estimate a VAR(p)-SV

% initialize the chain 
bigX = SURform2(X,n); 
Ha = speye(Tt*m) - sparse(m+1:Tt*m,1:(Tt-1)*m,ones((Tt-1)*m,1),Tt*m,Tt*m);
beta = (bigX'*bigX)\(bigX'*Yt);
h = repmat(log(var(reshape(Yt-bigX*beta,n,Tt)')),Tt,1);
a = zeros(Tt,m);
Sigh = .01*ones(n,1);
Siga = .01*ones(m,1);
Lfree = nonzeros(tril(reshape(1:n^2,n,n),-1));
L = eye(n); 
LDL = zeros(Tt*n,n);
s = zeros(Tt,n);    
   
rand('state', sum(100*clock) ); randn('state', sum(200*clock) );
    
for loop = 1:nloop

    %% sample beta
    expih = exp(-h);    
    for i=1:Tt
        L(Lfree) = a(i,:);
        LDL((i-1)*n+1:i*n,:) = L'*sparse(1:n,1:n,expih(i,:),n,n)*L;
    end
    XinvSig = bigX'*SURform3(LDL,n);
    XinvSigX = XinvSig*bigX;
    invDbeta = invVbeta + XinvSigX;
    betahat = invDbeta\(XinvSig*Yt);    
    flag = 0;
    count = 0;
    while flag == 0 && count < 100 % impose stationarity
        betac =  betahat + chol(invDbeta,'lower')'\randn(k,1);
        B = reshape(betac,p*n+1,n)';
        P(1:n,:) = B(:,2:end);
        if sum(abs(eig(P))<1) == p*n
            beta = betac;
            flag = 1;
        end
        count = count+1;
    end
    
        %% sample h  
    u = Yt-bigX*beta;
    shortu = reshape(u,n,Tt)';
    for i=1:Tt  
        L(Lfree) = a(i,:);
        s(i,:) = (L*shortu(i,:)')'.^2 ;
    end
    for i=1:n
        Ystar = log(s(:,i) + .0001 );
        h(:,i) = SVRW(Ystar,h(:,i),Sigh(i),Vh);
    end
    
    %% sample L
    E = zeros(Tt*n,m);
    countE = 0;
    for ii=1:n-1
        E(ii+1:n:end,countE+1:countE+ii) = shortu(:,1:ii);        
        countE=countE+ii;
    end
    bigE = SURform3(-E,n);
    EinvD = bigE'*sparse(1:Tt*n,1:Tt*n,reshape(exp(-h)',1,Tt*n),Tt*n,Tt*n);
    EinvDE = EinvD*bigE;
    Ka = Ha'*sparse(1:Tt*m,1:Tt*m,[1./Va; repmat(1./Siga,Tt-1,1)])*Ha + EinvDE;
    ahat = Ka\(EinvD*u); 
    longa = ahat + chol(Ka,'lower')'\randn(Tt*m,1);
    a = reshape(longa,m,Tt)'; 
    
        %% sample Sigh
    e2 = (h(2:Tt,:) - h(1:Tt-1,:)).^2;
    Sigh = sample_Sig(Sigh,e2,VSigh);    
      
        %% sample Siga
    e2 = (a(2:Tt,:) - a(1:Tt-1,:)).^2;
    Siga = sample_Sig(Siga,e2,VSiga);    
        
    if loop>burnin %% compute various forecasts
        compute_forecast_VAR_SV
    end    
end    
maxy1 = max(tempyhat1);
maxy2 = max(tempyhat2);
maxy3 = max(tempyhat3);    
